/*
    $Id: apply_to_all.h 273 2012-02-22 09:42:17Z matwey $
    Copyright (C) 2009  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _APPLY_TO_ALL_H
#define _APPLY_TO_ALL_H

#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector.hpp>

namespace utils {
namespace ublas {

using namespace boost::numeric::ublas;

/* examples from effective ublas are used here */
template<class OP, class E> BOOST_UBLAS_INLINE typename vector_unary_traits<E, OP>::result_type apply_to_all(const vector_expression<E> &e, const OP& op = OP() ) {
	typedef typename vector_unary_traits<E, OP>::expression_type expression_type;
	return expression_type (e ());
}
template<class OP, class E> BOOST_UBLAS_INLINE typename matrix_unary1_traits<E, OP>::result_type apply_to_all(const matrix_expression<E> &e, const OP& op = OP() ) {
	typedef typename matrix_unary1_traits<E, OP>::expression_type expression_type;
	return expression_type (e ());
}

} //ublas
} //utils

#endif // _APPLY_TO_ALL_H
