/*
    $Id: local_context.h 180 2011-01-30 15:56:33Z matwey $
    Copyright (C) 2011  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _LOCAL_CONTEXT_H
#define _LOCAL_CONTEXT_H

namespace utils {

template<class Context> class local_context {
	public:
		typedef Context                context_type;
		typedef context_type&          context_reference_type;
		typedef const context_type&    context_const_reference_type;
		typedef local_context<Context> local_context_type;
	private:
		context_reference_type m_ctx;
	protected:
		inline context_reference_type       context()       throw() { return m_ctx; }
		inline context_const_reference_type context() const throw() { return m_ctx; }
	public:
		local_context( context_reference_type ctx ) throw() : m_ctx(ctx) {}
};

}

#endif // _LOCAL_CONTEXT_H
