/*
    $Id: main.cpp 180 2011-01-30 15:56:33Z matwey $
    Copyright (C) 2009  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <boost/program_options.hpp>

#include "worksheet.h"

int main( int argc, char **argv ) {
	using atmos::worksheet;
	
	boost::program_options::variables_map va;

	if( worksheet::parse_program_options( argc, argv, va ) ) {
		return 1;
	}

	try {
		worksheet w( va );
		
		w.pre();
		w.run();
		w.post();

	} catch ( const std::exception& e ) {
		std::cerr << e.what() << std::endl;
		return 1;
	}
	
	return 0;
}
