/*
    $Id: nocase_less.h 143 2010-04-04 08:42:34Z matwey $
    Copyright (C) 2009  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _NOCASE_LESS_H
#define _NOCASE_LESS_H

#include <algorithm>
#include <cctype>

namespace utils {
namespace algo {

template<class T> class nocase_less {
	public:
		typedef T string_type;
	private:
		static bool nocase_cmp( typename string_type::value_type c1, typename string_type::value_type c2 ) {
			return std::toupper( c1 ) < std::toupper( c2 );
		}
	public:
		nocase_less() {}
		/* it is a less function */
		bool operator()( const string_type& s1, const string_type& s2 ) const {
			return std::lexicographical_compare( s1.begin(), s1.end(), s2.begin(), s2.end(), &nocase_cmp );
		}
};

} // algo
} // utlis

#endif // _NOCASE_LESS_H
