/*
    $Id: typesdef.h 180 2011-01-30 15:56:33Z matwey $
    Copyright (C) 2009  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _TYPESDEF_H
#define _TYPESDEF_H

#include <yalpa/spheric.h>

namespace atmos {

struct object {
	unsigned int hd;
	double       vmag;
	double       bvind;
	std::string  name;
	yalpa::equatorial<double> coordinates;
	std::string  sclass;
};

struct datum {
	double mean;
	double errs;
	datum( double m = 0.0, double e = 0.0 ) : mean(m), errs(e) {}
};

}

#endif // _TYPESDEF_H
