/*
    $Id: unstable_remove_if.h 143 2010-04-04 08:42:34Z matwey $
    Copyright (C) 2010  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _UNSTABLE_REMOVE_IF_H
#define _UNSTABLE_REMOVE_IF_H

#include <algorithm>
#include <cctype>

namespace utils {
namespace algo {

template<class ForwardIterator, class Predicate> ForwardIterator unstable_remove_if( ForwardIterator first, ForwardIterator last, Predicate pred ) {
	using namespace std;

	ForwardIterator it = first;
	ForwardIterator end = last;

	while( it != end ) {
		if( pred( *it ) ) {
			iter_swap( it, --end );
		} else
			++it;
	}

	return end;
}

} // algo
} // utlis

#endif // _UNSTABLE_REMOVE_IF_H
