/*
    $Id: sidtime.h 29 2013-02-24 10:21:34Z matwey $
    Copyright (C) 2010  Matwey V. Kornilov <matwey.kornilov@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SIDTIME_H
#define _SIDTIME_H

#include <cmath>
#include <ctime>

#include <boost/date_time/posix_time/posix_time.hpp>

namespace yalpa {

	double julian( const std::time_t& epoch );
	std::time_t epoch( double julian );

	double sidereal_time( const std::time_t& epoch );
	double sidereal_time( double julian );
	double from_sidereal( double sid, double julian0 );

	double julian( const boost::posix_time::ptime& time );
	double sidereal_time( const boost::posix_time::ptime& time );
};

#endif // _SIDTIME_H
