/*
    $Id: sun.h 32 2013-08-04 15:27:24Z matwey $
    Copyright (C) 2010  Matwey V. Kornilov <matwey.kornilov@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SUN_H
#define _SUN_H

#include <yalpa/spheric.h>

#include <cmath>
#include <ctime>

#include <boost/date_time/posix_time/posix_time.hpp>

namespace yalpa {

	double sun_longitude( const std::time_t& epoch );
	double sun_longitude( double julian );

	ecliptic<double> sun_position( double julian );
	ecliptic<double> sun_position( const std::time_t& epoch );

	double sun_longitude( const boost::posix_time::ptime& time );
	ecliptic<double> sun_position( const boost::posix_time::ptime& time );

	double sunset_time( double jday, const geographic<double>& location );
	std::time_t sunset_time( const std::time_t& day, const geographic<double>& location );
	double sunrise_time( double jday, const geographic<double>& location );
	std::time_t sunrise_time( const std::time_t& day, const geographic<double>& location );
};

#endif // _SIDTIME_H
