/*
    $Id: io.cpp 6 2010-01-18 16:16:45Z matwey $
    Copyright (C) 2010  Matwey V. Kornilov <matwey.kornilov@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include <yalpa/io.h>

namespace std {

static const int unit_index = std::ios_base::xalloc();
static const int base_index = std::ios_base::xalloc();

};

bool std::is_degrees( std::ostream& stm ) {
	return stm.iword(unit_index) == 1;
}
bool std::is_degrees( std::istream& stm ) {
	return stm.iword(unit_index) == 1;
}
bool std::is_hours( std::ostream& stm ) {
	return stm.iword(unit_index) == 2;
}
bool std::is_hours( std::istream& stm ) {
	return stm.iword(unit_index) == 2;
}
bool std::is_sexagesimal( std::ostream& stm ) {
	return stm.iword(base_index) == 1;
}
bool std::is_sexagesimal( std::istream& stm ) {
	return stm.iword(base_index) == 1;
}
	
std::ostream& std::degrees( std::ostream& stm ) {
	stm.iword(unit_index) = 1;
	return stm;
}
std::istream& std::degrees( std::istream& stm ) {
	stm.iword(unit_index) = 1;
	return stm;
}
std::ostream& std::hours( std::ostream& stm ) {
	stm.iword(unit_index) = 2;
	return stm;
}
std::istream& std::hours( std::istream& stm ) {
	stm.iword(unit_index) = 2;
	return stm;
}
std::ostream& std::radians( std::ostream& stm ) {
	stm.iword(unit_index) = 0;
	return stm;
}
std::istream& std::radians( std::istream& stm ) {
	stm.iword(unit_index) = 0;
	return stm;
}
std::ostream& std::decimal( std::ostream& stm ) {
	stm.iword(base_index) = 0;
	return stm;
}
std::istream& std::decimal( std::istream& stm ) {
	stm.iword(base_index) = 0;
	return stm;
}
std::ostream& std::sexagesimal( std::ostream& stm ) {
	stm.iword(base_index) = 1;
	return stm;
}
std::istream& std::sexagesimal( std::istream& stm ) {
	stm.iword(base_index) = 1;
	return stm;
}