/*
    $Id: julian.cpp 5 2010-01-17 11:19:09Z matwey $
    Copyright (C) 2010  Matwey V. Kornilov <matwey.kornilov@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <ctime>
#include <iostream>

#include <yalpa/io.h>
#include <yalpa/sidtime.h>

int main( int argc, char** argv ){

	std::time_t now = std::time( NULL );

	std::cout << "Now (UTC):   " << std::asctime( std::gmtime( &now ) ) << std::endl;
	std::cout << "Now (local): " << std::asctime( std::localtime( &now ) ) << std::endl;
	std::cout << "Julian date: " << std::fixed << yalpa::julian( now ) << std::endl;
	std::cout << "GMT siderial:" << std::hours << std::sexagesimal << yalpa::make_angle(yalpa::sidereal_time( now )) << std::endl;
	std::cout << std::endl;

	return 0;
}

