#define BOOST_TEST_MODULE julian_test
#include <boost/test/included/unit_test.hpp>

#include <ctime>
#include <yalpa/sidtime.h>

using namespace yalpa;

BOOST_AUTO_TEST_CASE(julian1) {
	std::time_t cur = std::time(NULL);
	double jcur = julian(cur);
	std::time_t jjcur = epoch(jcur);
	BOOST_CHECK_EQUAL(cur,jjcur);
}

BOOST_AUTO_TEST_CASE(julian2) {
	double j1 = 2451545.000000;
	std::time_t e1 = 946728000L;
	double j2 = 2440587.500000;
	std::time_t e2 = 0;
	BOOST_CHECK_EQUAL(j1,julian(e1));
	BOOST_CHECK_EQUAL(j2,julian(e2));
}

BOOST_AUTO_TEST_CASE(epoch1) {
	double j1 = 2451545.000000;
	std::time_t e1 = 946728000L;
	double j2 = 2440587.500000;
	std::time_t e2 = 0;
	BOOST_CHECK_EQUAL(e1,epoch(j1));
	BOOST_CHECK_EQUAL(e2,epoch(j2));
}

