#define BOOST_TEST_MODULE moon_test
#include <boost/test/included/unit_test.hpp>

#include <yalpa/moon.h>

using namespace yalpa;

BOOST_AUTO_TEST_CASE(moon_pos) {
	ecliptic<double> m = moon_position(2456699.083924);
	BOOST_CHECK_CLOSE(m.longitude(), 1.6345357510777296, 1e-2);
	BOOST_CHECK_CLOSE(m.latitude(), -0.0779987642716266, 1e-1);
	ecliptic<double> m2 = moon_position(2448724.5);
	BOOST_CHECK_CLOSE(m2.longitude(), 2.3241268402604596, 1e-2);
	BOOST_CHECK_CLOSE(m2.latitude(), -0.056359590428983565, 1e-2);
}
