#define BOOST_TEST_MODULE sidtime_test
#include <boost/test/included/unit_test.hpp>

#include <ctime>
#include <yalpa/sidtime.h>

using namespace yalpa;

BOOST_AUTO_TEST_CASE(sidtime1) {
	double j0 = julian(std::time(NULL));
	double sid = sidereal_time(j0);
	double jj0 = from_sidereal(sid, j0);
	BOOST_CHECK_CLOSE(j0,jj0,1e-12);		
}

BOOST_AUTO_TEST_CASE(sidtime2) {
	double j0 = julian(std::time(NULL));
	for(double sid=0.05;sid<2*M_PI;sid+=0.1){
		double jj0 = from_sidereal(sid, j0);
		double ssid = sidereal_time(jj0);
		BOOST_CHECK_CLOSE(sid,ssid,1e-5);
	}
}

BOOST_AUTO_TEST_CASE(sidtime3) {
	for(double j0=2456340.0;j0<2456341.0;j0+=0.1){
		double jj0 = from_sidereal(sidereal_time(j0),j0);
		BOOST_CHECK_CLOSE(j0,jj0,1e-12);
	}
}

